import Kalah
import MinMax
import qualified Data.Vector as V

testMakeMove1 :: Bool
testMakeMove1 = case maybeS of
  Nothing -> False
  Just (State _ turn) ->
    case turn of
      True -> False
      False -> True
  where maybeS = makeMove initState 0

testMakeMove2 :: Bool
testMakeMove2 = case maybeS of
  Nothing -> False
  Just (State _ turn) ->
    case turn of
      True -> True
      False -> False
  where maybeS = makeMove initState 2

testIsTerm1 :: Bool
testIsTerm1 = not res
  where res = isTerm initState

testIsTerm2 :: Bool
testIsTerm2 = res
  where res = isTerm s
        s = State (V.generate 14 f) True
        f i
          | i == 5 = 4
          | otherwise = 0

testUtil1 :: Bool
testUtil1 = res == 0
  where res = util initState

testUtil2 :: Bool
testUtil2 = res == -18
  where res = util s
        s = State (V.generate 14 f) True
        f i
          | i == 8 = 20
          | i == 2 = 2
          | otherwise = 0

computeAIMove1 :: Bool
computeAIMove1 = move == 5
  where move = computeAIMove minMaxConfig initState
        minMaxConfig = MinMaxConfig SeqMM 9 (-1)

computeAIMove2 :: Bool
computeAIMove2 = move == 5
  where move = computeAIMove minMaxConfig initState
        minMaxConfig = MinMaxConfig SeqAB 9 (-1)

computeAIMove3 :: Bool
computeAIMove3 = move == 5
  where move = computeAIMove minMaxConfig initState
        minMaxConfig = MinMaxConfig ParThenMM 9 2

computeAIMove4 :: Bool
computeAIMove4 = move == 5
  where move = computeAIMove minMaxConfig initState
        minMaxConfig = MinMaxConfig ParThenAB 9 2

computeAIMove5 :: Bool
computeAIMove5 = move == 5
  where move = computeAIMove minMaxConfig initState
        minMaxConfig = MinMaxConfig YoungBros 9 2

aiMoveTestState :: State
aiMoveTestState = State (V.generate 14 f) False
  where f i
          | i < 3 = 4
          | 3 <= i && i <= 6 = 3
          | 7 <= i && i <= 10 = 1
          | otherwise = 6

computeAIMove6 :: Bool
computeAIMove6 = move == 9
  where move = computeAIMove minMaxConfig aiMoveTestState
        minMaxConfig = MinMaxConfig SeqMM 9 (-1)

computeAIMove7 :: Bool
computeAIMove7 = move == 9
  where move = computeAIMove minMaxConfig aiMoveTestState
        minMaxConfig = MinMaxConfig SeqAB 9 (-1)

computeAIMove8 :: Bool
computeAIMove8 = move == 9
  where move = computeAIMove minMaxConfig aiMoveTestState
        minMaxConfig = MinMaxConfig ParThenMM 9 (-1)

computeAIMove9 :: Bool
computeAIMove9 = move == 9
  where move = computeAIMove minMaxConfig aiMoveTestState
        minMaxConfig = MinMaxConfig ParThenAB 9 (-1)

computeAIMove10 :: Bool
computeAIMove10 = move == 9
  where move = computeAIMove minMaxConfig aiMoveTestState
        minMaxConfig = MinMaxConfig YoungBros 9 (-1)

main :: IO ()
main = do
  let res = and [testMakeMove1, testMakeMove2,
                 testIsTerm1, testIsTerm2,
                 testUtil1, testUtil2,
                 computeAIMove1, computeAIMove2,
                 computeAIMove3, computeAIMove4,
                 computeAIMove5, computeAIMove6,
                 computeAIMove6, computeAIMove7,
                 computeAIMove8, computeAIMove9,
                 computeAIMove10]
  if res then
    putStrLn "Tests Passed!"
  else
    error "Some Tests Failed."
